<template>
  <section class="relative">
    <div class="relative">
      <slot />
      <div
        v-if="store.draggingTask"
        class="absolute -top-5 bottom-0 flex w-full flex-col"
      >
        <DropArea
          class="h-4"
          @drop="$emit('drop', { type: 'before', taskId: $event as string })"
        />
        <DropArea
          class="grow opacity-20"
          @drop="$emit('drop', { type: 'inside', taskId: $event as string })"
        />
      </div>
    </div>
    <slot name="children" />
    <DropArea
      v-if="store.draggingTask"
      class="absolute -bottom-5 h-4 w-full"
      @drop="$emit('drop', { type: 'after', taskId: $event as string })"
    />
  </section>
</template>

<script setup lang="ts">
import { useTasksStore } from '~/stores/tasks';
import { DropArea } from '~entities/dragAndDrop';
import { type DropTaskEvent } from '~entities/tasks';

defineEmits<{
  (e: 'drop', id: DropTaskEvent): void;
}>();
const store = useTasksStore();
</script>
